Index: trunk/drmaa_utils/drmaa_utils/util.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/util.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/util.h	(revision 1)
@@ -0,0 +1,155 @@
+/* $Id: util.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file util.h
+ * Various functions.
+ */
+
+#ifndef __DRMAA_UTILS__UTIL_H
+#define __DRMAA_UTILS__UTIL_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <time.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/compat.h>
+
+char *fsd_explode( const char *const *vector, char glue, int n );
+void fsd_free_vector( char **vector );
+char **fsd_copy_vector( const char *const * vector );
+char *fsd_replace( char *input, const char *placeholder, const char *value );
+
+char *fsd_strdup( const char *s );
+char *fsd_strndup( const char *s, size_t n );
+
+int fsd_atoi( const char *s );
+
+void
+fsd_str_append(
+		bool *truncated,
+		char **p, char *end,
+		const char *fmt, ...
+		)
+		__attribute__(( format( printf, 4, 5 ) ));
+
+size_t
+fsd_snprintf(
+		bool *truncated,
+		char *str, size_t size,
+		const char *fmt, ...
+		)
+		__attribute__(( format( printf, 4, 5 ) ));
+
+size_t
+fsd_vsnprintf(
+		bool *truncated,
+		char *str, size_t size,
+		const char *fmt, va_list args
+		);
+
+/**
+ * Behaves like asprintf function from standard C library
+ * except any errors are marked in error context structure.
+ *
+ * It substitutes `%m` format string as in glibc
+ * (with `strerror(errno)`).
+ */
+char *fsd_asprintf( const char *fmt, ... )
+		__attribute__(( format( __printf__, 1, 2 ) ));
+
+/**
+ * Behaves like vasprintf function from standard C library
+ * except any errors are marked in error context structure.
+ */
+char *fsd_vasprintf( const char *fmt, va_list args );
+
+/**
+ * Implements GNU version of strerror_r function - thread-safe
+ * function returning message describing error code.
+ *
+ * From Linux Programmer's Manual:
+ *
+ * <code> char *strerror_r(int errnum, char *buf, size_t buflen); </code>
+ *
+ * The GNU-specific strerror_r() returns a pointer to a string containing
+ * the error message.  This may be either a pointer to a string that the
+ * function stores in buf, or a pointer to some (immutable) static string
+ * (in which case buf is unused).  If the function stores a string in
+ * buf, then at most buflen bytes are stored (the string may be truncated
+ * if buflen is too small) and the string always includes a terminating
+ * null byte.
+ */
+const char *
+fsd_strerror_r( int errnum, char *buffer, size_t buffer_size );
+
+char *
+fsd_astrerror( int errnum, bool *malloced );
+
+/** Retrievs current system timestamp. */
+void fsd_get_time( struct timespec *ts );
+
+/** Add delta to timestamp. */
+void fsd_ts_add( struct timespec *a, const struct timespec *b );
+
+/**
+ * Compares two timestamps.
+ * @return Negative integer when a < b (a represents earlier timestamp),
+ *   positive integer when a > b or 0 when timestamps are equal.
+ */
+int fsd_ts_cmp( const struct timespec *a, const struct timespec *b );
+
+/**
+ * Reads file contents.
+ * @param filename  Path to the file.
+ * @param must_exist  Controls behaviour when file not exist
+ *   (or is not readable).  If set to \c true DRMAA_ERRNO_INTERNAL_ERROR
+ *   is raised on such occasion.  If set to \c false only
+ *   \a content is set to \c NULL and no error is raised.
+ * @param content  Filled with pointer to buffer with file contents
+ *   or \c NULL when error is encoureged.  Caller is responsible
+ *   for free()'ing it.
+ * @param length  Filled with length of \a content buffer.
+ */
+void
+fsd_read_file(
+		const char *filename, bool must_exist,
+		char **content, size_t *length
+		);
+
+/**
+ * Gets path to current working directory.
+ * @return  Path to process's current working directory
+ *   in malloc'ed '\0' terminated buffer
+ *   or \c NULL in case of error.
+ */
+char *
+fsd_getcwd(void);
+
+/**
+ * Returns signal name.
+ * @param signum  Valid signal number.
+ */
+const char *
+fsd_strsignal( int signum );
+
+#endif /* __DRMAA_UTILS__UTIL_H */
Index: trunk/drmaa_utils/drmaa_utils/conf.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/conf.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/conf.c	(revision 1)
@@ -0,0 +1,579 @@
+/* $Id: conf.c 226 2010-05-25 10:47:18Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <ctype.h>
+#include <stdarg.h>
+#include <string.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/conf_impl.h>
+#include <drmaa_utils/conf_tab.h>
+#include <drmaa_utils/logging.h>
+#include <drmaa_utils/util.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: conf.c 226 2010-05-25 10:47:18Z mamonski $";
+#endif
+
+
+fsd_conf_dict_t *
+fsd_conf_read(
+	        fsd_conf_dict_t  * volatile configuration,
+		const char *filename, bool must_exist,
+		const char *content, size_t content_len
+		)
+{
+	fsd_conf_dict_t *volatile result = NULL;
+	fsd_conf_parser_t *parser = NULL;
+	fsd_conf_lexer_t *lexer = NULL;
+	char *file_content = NULL;
+	size_t file_content_len = 0;
+
+	fsd_log_enter((
+		"(filename=%s, must_exist=%s, content=%s)",
+		filename, must_exist ? "true" : "false", content
+		));
+
+	TRY
+	 {
+		fsd_malloc( parser, fsd_conf_parser_t );
+		fsd_malloc( lexer, fsd_conf_lexer_t );
+
+		parser->lexer = lexer;
+		parser->result = NULL;
+		parser->n_errors = 0;
+		parser->errors = NULL;
+
+		lexer->parser = parser;
+		lexer->filename = filename;
+		lexer->buffer = NULL;
+		lexer->buflen = 0;
+		lexer->pos = NULL;
+		lexer->lineno = 0;
+		lexer->cline = NULL;
+
+		if( filename )
+			TRY
+			 {
+				fsd_read_file(
+						filename, must_exist,
+						&file_content, &file_content_len
+						);
+			 }
+			EXCEPT_DEFAULT
+			 {
+				const fsd_exc_t *e = fsd_exc_get();
+				if( must_exist )
+					fsd_exc_raise_fmt( e->code(e), "%s: %s", filename, e->message(e) );
+				else
+				 {
+					fsd_log_warning(( "%s: %s", filename, e->message(e) ));
+				 }
+			 }
+			END_TRY
+
+		if( file_content )
+		 {
+			lexer->buffer = (const uchar*)file_content;
+			lexer->buflen = file_content_len;
+			fsd_log_trace(( "content from file" ));
+		 }
+		else if( content )
+		 {
+			lexer->buffer = (const uchar*)content;
+			lexer->buflen = content_len;
+			fsd_log_trace(( "content from memory" ));
+		 }
+
+		if( lexer->buffer )
+		 {
+			lexer->pos = lexer->cline = lexer->buffer;
+			lexer->lineno = 1;
+
+			fsd_conf_parse( parser, lexer );
+			result = parser->result;
+		 }
+
+		if( parser->n_errors > 0 )
+		 {
+			fsd_exc_raise(
+					fsd_exc_new(
+							FSD_ERRNO_INTERNAL_ERROR,
+							fsd_explode( (const char*const*)parser->errors, '\n',
+								parser->n_errors ),
+							true
+							)
+					);
+		 }
+	 }
+	ELSE
+	 {
+		configuration = fsd_conf_dict_merge( configuration, result );
+		result = NULL;
+	 }
+	FINALLY
+	 {
+		if( parser )
+		 {
+			if( parser->errors )
+			 {
+				int i;
+				for( i=0;  i < parser->n_errors;  i++ )
+					fsd_free( parser->errors[i] );
+				fsd_free( parser->errors );
+			 }
+			fsd_free( parser );
+		 }
+		fsd_free( lexer );
+		fsd_free( file_content );
+		fsd_conf_dict_destroy( result );
+	 }
+	END_TRY
+
+	fsd_log_return(( "" ));
+	return configuration;
+}
+
+
+
+int
+fsd_conf_lex(
+		union YYSTYPE *lvalp, struct YYLTYPE *locp,
+		fsd_conf_lexer_t *lexer
+		)
+{
+	const uchar *c = lexer->pos;
+	const uchar *end = lexer->buffer + lexer->buflen;
+	const char *error = NULL;
+	int result;
+
+	while( c<end )
+		switch( *c )
+		 {
+			case '#':  /* a comment */
+				while( c<end && *c != '\n' )
+					c++;
+			case '\n':  /* no break */
+				lexer->lineno++;
+				lexer->cline = c+1;
+			case ' ':  case '\t':  case '\r':  /* no break */
+				c++;
+				break;
+			default:
+				goto token_begin;
+		 }
+
+token_begin:
+	locp->first_line = lexer->lineno;
+	locp->first_column = c - lexer->cline + 1;
+
+	if( c == end )
+		result = 0;
+	else
+		switch( *c )
+		 {
+			case ':':  case ',':  case '{':  case '}':
+				result = *c++;
+				break;
+
+			case '0':  case '1':  case '2':  case '3':  case '4':
+			case '5':  case '6':  case '7':  case '8':  case '9':
+			 {
+				int v = 0;
+				while( c < end  &&  '0' <= *c  &&  *c <= '9' )
+				 {
+					v *= 10;
+					v += *c - '0';
+					c++;
+				 }
+				lvalp->integer = v;
+				result = INTEGER;
+				break;
+			 }
+
+			case '"':  case '\'':
+			 {
+				uchar delimiter;
+				const uchar *begin;
+				delimiter = *c++;
+				begin = c;
+                                
+				while( c < end  &&  *c != delimiter )
+					c++;
+				if( c == end )
+				 {
+					error = "expected string delimiter but EOF found";
+					result = LEXER_ERROR;
+				 }
+				else
+				 {
+					lvalp->string = fsd_strndup( (const char*)begin, c-begin );
+					result = STRING;
+					c++;
+				 }
+				break;
+			 }
+
+			default:
+			 {
+				const uchar *begin = c;
+				while( c<end  &&  !isspace(*c) )
+					switch( *c )
+					 {
+						case ':':  case ',':  case '{':  case '}':
+							goto end_of_string;
+						default:
+							c++;
+							break;
+					 }
+			end_of_string:
+				lvalp->string = fsd_strndup( (const char*)begin, c-begin );
+				result = STRING;
+				break;
+			 }
+		 }
+
+	locp->last_line = lexer->lineno;
+	locp->last_column = c - lexer->cline;
+	if( locp->last_column < locp->first_column )
+		locp->last_column = locp->first_column;
+	lexer->pos = c;
+
+	if( error )
+		fsd_conf_error( locp, lexer->parser, lexer, error );
+
+	return result;
+}
+
+
+
+void
+fsd_conf_error(
+		struct YYLTYPE *locp,
+		fsd_conf_parser_t *parser, fsd_conf_lexer_t *lexer,
+		const char *fmt, ...
+		)
+{
+	char *volatile message = NULL;
+	va_list args;
+
+	TRY
+	 {
+		va_start( args, fmt );
+		message = fsd_vasprintf( fmt, args );
+		va_end( args );
+
+		fsd_realloc( parser->errors, parser->n_errors+1, char* );
+		parser->errors[ parser->n_errors ] = fsd_asprintf(
+				"%s:%d:%d: %s",
+				parser->lexer->filename, locp->first_line, locp->first_column,
+				message );
+		fsd_log_error(("Parser error: %s:%d:%d: %s", parser->lexer->filename, locp->first_line, locp->first_column, message ));
+		parser->n_errors ++;
+	 }
+	FINALLY
+	 { fsd_free( message ); }
+	END_TRY
+}
+
+
+
+fsd_conf_option_t *
+fsd_conf_option_create( fsd_conf_type_t type, void *value )
+{
+	fsd_conf_option_t *o = NULL;
+
+	fsd_malloc( o, fsd_conf_option_t );
+	o->type = type;
+	switch( type )
+	 {
+		case FSD_CONF_INTEGER:
+			o->val.integer = *(int*)value;
+			break;
+		case FSD_CONF_STRING:
+			o->val.string = (char*)value;
+			break;
+		case FSD_CONF_DICT:
+			o->val.dict = (fsd_conf_dict_t*)value;
+			break;
+		default:
+			fsd_assert(false);
+			break;
+	 }
+	return o;
+}
+
+
+void
+fsd_conf_option_destroy( fsd_conf_option_t *option )
+{
+	if( option == NULL )
+		return;
+	switch( option->type )
+	 {
+		case FSD_CONF_INTEGER:
+			break;
+		case FSD_CONF_STRING:
+			fsd_free( option->val.string );
+			break;
+		case FSD_CONF_DICT:
+			fsd_conf_dict_destroy( option->val.dict );
+			break;
+		default:
+			fsd_assert( false );
+	 }
+	fsd_free( option );
+}
+
+
+fsd_conf_option_t *
+fsd_conf_option_merge( fsd_conf_option_t *lhs, fsd_conf_option_t *rhs )
+{
+	if( lhs->type == rhs->type  &&  rhs->type == FSD_CONF_DICT )
+	 {
+		lhs->val.dict = fsd_conf_dict_merge( lhs->val.dict, rhs->val.dict );
+		fsd_free( rhs );
+		return lhs;
+	 }
+	else
+	 {
+		fsd_conf_option_destroy( lhs );
+		return rhs;
+	 }
+}
+
+
+void
+fsd_conf_option_dump( fsd_conf_option_t *option )
+{
+	if( option == NULL )
+	 {
+		printf( "(null)" );
+		return;
+	 }
+	switch( option->type )
+	 {
+		case FSD_CONF_STRING:
+			printf( "\"%s\"", option->val.string );
+			break;
+		case FSD_CONF_INTEGER:
+			printf( "%d", option->val.integer );
+			break;
+		case FSD_CONF_DICT:
+			fsd_conf_dict_dump( option->val.dict );
+			break;
+	 }
+}
+
+
+
+struct fsd_conf_dict_s {
+	fsd_conf_dict_t *next;
+	char *key;
+	fsd_conf_option_t *value;
+};
+
+
+fsd_conf_dict_t *
+fsd_conf_dict_create(void)
+{
+	fsd_conf_dict_t *dict = NULL;
+	fsd_malloc( dict, fsd_conf_dict_t );
+	dict->next = NULL;
+	dict->key = NULL;
+	dict->value = NULL;
+	return dict;
+}
+
+
+void
+fsd_conf_dict_destroy( fsd_conf_dict_t *dict )
+{
+	fsd_conf_dict_t *i;
+	for( i = dict;  i != NULL;  )
+	 {
+		fsd_conf_dict_t *c = i;
+		i = i->next;
+		fsd_free( c->key );
+		fsd_conf_option_destroy( c->value );
+		fsd_free( c );
+	 }
+}
+
+
+fsd_conf_option_t *
+fsd_conf_dict_get(
+		fsd_conf_dict_t *dict, const char *key )
+{
+	fsd_conf_dict_t *i;
+	if( dict == NULL  ||  key == NULL )
+		return NULL;
+	for( i = dict->next;  i != NULL;  i = i->next )
+	 {
+		if( !strcmp( i->key, key ) )
+			return i->value;
+	 }
+	return NULL;
+}
+
+
+void
+fsd_conf_dict_set(
+		fsd_conf_dict_t *dict, const char *key, fsd_conf_option_t *value
+		)
+{
+	fsd_conf_dict_t *i;
+	for( i = dict->next;  i != NULL;  i = i->next )
+	 {
+		if( !strcmp( i->key, key ) )
+			break;
+	 }
+
+	if( i != NULL )
+	 {
+		fsd_conf_option_destroy( i->value );
+		i->value = value;
+	 }
+	else
+	 {
+		fsd_conf_dict_t* volatile n = NULL;
+		TRY
+		 {
+			fsd_malloc( n, fsd_conf_dict_t );
+			n->key = fsd_strdup( key );
+			n->value = value;
+		 }
+		EXCEPT_DEFAULT
+		 {
+			fsd_free( n );
+			fsd_exc_reraise();
+		 }
+		ELSE
+		 {
+			n->next = dict->next;
+			dict->next = n;
+		 }
+		END_TRY
+	 }
+}
+
+
+fsd_conf_dict_t *
+fsd_conf_dict_merge( fsd_conf_dict_t *lhs, fsd_conf_dict_t *rhs )
+{
+	fsd_conf_dict_t *i, *j;
+
+	if( lhs == NULL )
+		return rhs;
+
+	if( rhs == NULL )
+		return lhs;
+
+	for( j = rhs->next;  j != NULL;  )
+	 {
+		fsd_conf_dict_t *r = j;
+		j = j->next;
+
+		for( i = lhs->next;  i != NULL;  i = i->next )
+			if( !strcmp( i->key, r->key ) )
+				break;
+
+		if( i != NULL )
+		 {
+			i->value = fsd_conf_option_merge( i->value, r->value );
+			fsd_free( r->key );
+			fsd_free( r );
+		 }
+		else
+		 {
+			r->next = lhs->next;
+			lhs->next = r;
+		 }
+	 }
+
+	fsd_free( rhs );
+	return lhs;
+}
+
+
+void
+fsd_conf_dict_dump( fsd_conf_dict_t *dict )
+{
+	fsd_conf_dict_t *i;
+
+	if( dict == NULL )
+	 {
+		printf( "(null)" );
+		return;
+	 }
+	printf( "{" );
+	for( i=dict->next;  i;  i = i->next )
+	 {
+		if( i != dict->next )
+			printf( "," );
+		printf( " %s=", i->key );
+		fsd_conf_option_dump( i->value );
+	 }
+	printf( " }" );
+}
+
+
+fsd_conf_option_t *
+fsd_conf_option_create_noraise( fsd_conf_type_t type, void *value )
+{
+	fsd_conf_option_t *volatile result = NULL;
+	TRY{ result = fsd_conf_option_create( type, value ); }
+	EXCEPT_DEFAULT{}
+	END_TRY
+	return result;
+}
+
+fsd_conf_dict_t *
+fsd_conf_dict_create_noraise(void)
+{
+	fsd_conf_dict_t *volatile result = NULL;
+	TRY{ result = fsd_conf_dict_create(); }
+	EXCEPT_DEFAULT{}
+	END_TRY
+	return result;
+}
+
+int
+fsd_conf_dict_set_noraise(
+		fsd_conf_dict_t *dict, const char *key, fsd_conf_option_t *value )
+{
+	volatile int rc = FSD_ERRNO_SUCCESS;
+	TRY{ fsd_conf_dict_set( dict, key, value ); }
+	EXCEPT_DEFAULT
+	 {
+		const fsd_exc_t *e = fsd_exc_get();
+		rc = e->code(e);
+	 }
+	END_TRY
+	return rc;
+}
+
Index: trunk/drmaa_utils/drmaa_utils/logging.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/logging.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/logging.c	(revision 1)
@@ -0,0 +1,250 @@
+/* $Id: logging.c 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <sys/time.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdarg.h>
+#include <string.h>
+#include <unistd.h>
+#ifdef HAVE_EXECINFO_H
+#	include <execinfo.h>
+#endif
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/logging.h>
+#include <drmaa_utils/lookup3.h>
+#include <drmaa_utils/thread.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: logging.c 2 2009-10-12 09:51:22Z mamonski $";
+#endif
+
+
+static int fsd_logging_output = 2;
+
+fsd_verbose_level_t fsd_verbose_level =
+#ifdef DEBUGGING
+	FSD_LOG_TRACE
+#else
+	FSD_LOG_WARNING
+#endif
+;
+
+static struct timeval fsd_logging_start = {0, 0};
+
+
+void
+fsd_set_verbosity_level( fsd_verbose_level_t level )
+{
+	fsd_verbose_level = level;
+}
+
+void
+fsd_set_logging_fd( int fd )
+{
+	fsd_logging_output = fd;
+}
+
+
+void
+fsd_color( char *output, size_t len, int n )
+{
+	uint32_t k = n;
+	k = hashword( &k, 1, 0 );
+	k %= 12;
+	snprintf( output, len, "\033[0;%d;%dm", k>=6, 31+k%6 );
+}
+
+
+char
+fsd_log_level_char( int level )
+{
+	switch( level )
+	 {
+		case FSD_LOG_TRACE:    return 't';
+		case FSD_LOG_DEBUG:    return 'd';
+		case FSD_LOG_INFO:     return 'I';
+		case FSD_LOG_WARNING:  return 'W';
+		case FSD_LOG_ERROR:    return 'E';
+		case FSD_LOG_FATAL:    return 'F';
+		default:               return '?';
+	 }
+}
+
+
+void
+_fsd_log( int level, const char *file, const char *function,
+		int kind, char *message )
+{
+	const bool color = false;
+	char colorbeg[16];
+	const char *colorend;
+	int tid;
+	long int seconds, microseconds;
+	const char *prefix;
+	const char *p;
+
+	if( level < (int)fsd_verbose_level )
+		return;
+
+	if( message == NULL )
+		return;
+
+	tid = fsd_thread_id();
+	if( color )
+	 {
+		fsd_color( colorbeg, sizeof(colorbeg), tid );
+		colorend = "\033[0m";
+	 }
+	else
+	 {
+		colorbeg[0] = '\0';
+		colorend = "";
+	 }
+
+	 {
+		struct timeval tv;
+		gettimeofday( &tv, NULL );
+		seconds = tv.tv_sec;
+		microseconds = tv.tv_usec;
+	 }
+	if( fsd_logging_start.tv_sec == 0 )
+	 {
+		time_t t;
+		struct tm utc;
+		char rep[32];
+		fsd_logging_start.tv_sec = seconds;
+		fsd_logging_start.tv_usec = microseconds;
+		t = seconds;
+		gmtime_r( &t, &utc );
+		strftime( rep, sizeof(rep), "%Y-%m-%d %H:%M:%S", &utc );
+		fsd_log_debug(( "logging started at: %s.%02ld Z",
+					rep, microseconds/10000 ));
+	 }
+	if( microseconds < fsd_logging_start.tv_usec )
+	 {
+		seconds --;
+		microseconds += 1000000;
+	 }
+	seconds -= fsd_logging_start.tv_sec;
+	microseconds -= fsd_logging_start.tv_usec;
+
+	switch( kind )
+	 {
+		case _FSD_LOG_ENTER:   prefix = "->";  break;
+		case _FSD_LOG_RETURN:  prefix = "<-";  break;
+		default:
+			prefix = " *";
+			function = "";
+			break;
+	 }
+
+	p = message;
+	do {
+		if( *p == '\n' )
+		 {
+			prefix = " |";
+			function = "";
+			p++;
+		 }
+		else
+		 {
+			const char *end;
+			char *line = NULL;
+			int rc;
+			end = strchr( p, '\n' );
+			if( end == NULL )
+				end = p + strlen(p);
+			rc = asprintf( &line, "%c #%s%04x%s [%6ld.%02ld] %s %s%.*s\n",
+					fsd_log_level_char(level), colorbeg, tid, colorend,
+					seconds, microseconds/10000, prefix, function, (int)(end-p), p
+					);
+			if( rc != -1 )
+				write( fsd_logging_output, line, strlen(line) );
+			else
+				return;
+			free( line );
+			p = end;
+		 }
+	} while( *p != '\0' );
+
+	free( message );
+}
+
+
+void
+fsd_log_fmt( int level, const char *fmt, ... )
+{
+	va_list args;
+	va_start( args, fmt );
+	fsd_log_fmtv( level, fmt, args );
+	va_end( args );
+}
+
+
+void
+fsd_log_fmtv( int level, const char *fmt, va_list args )
+{
+	_fsd_log( level, NULL, NULL, _FSD_LOG_MSG, fsd_vasprintf(fmt, args) );
+}
+
+
+#if defined(__GNUC__) && defined(HAVE_EXECINFO_H)
+#define MAX_STACKTRACE 128
+void
+fsd_log_stacktrace( int skip, int limit )
+{
+	void **ptr_buf = NULL;
+	const char **symbols = NULL;
+	int i, n;
+
+	if( limit == 0 )
+		limit = 128;
+	skip++; /* without fsd_log_stacktrace() frame */
+	n = skip + limit;
+
+	ptr_buf = (void**)calloc( n, sizeof(void*) );
+	if( ptr_buf == NULL )
+		return;
+	n = backtrace( ptr_buf, n );
+	symbols = (const char**)backtrace_symbols( ptr_buf, n );
+	if( symbols != NULL )
+	 {
+		fsd_log_debug(( "Stacktrace (most recent call last):" ));
+		for( i = n-skip;  i >= 0;  i-- )
+			fsd_log_debug(( "\n  %s", symbols[i] ));
+		free( symbols );
+	 }
+}
+#else
+void fsd_log_stacktrace( int skip, int limit ) {}
+#endif
+
+
+
Index: trunk/drmaa_utils/drmaa_utils/session.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/session.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/session.h	(revision 1)
@@ -0,0 +1,331 @@
+/* $Id: session.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file session.h
+ * DRMAA session.
+ */
+
+#ifndef __DRMAA_UTILS__SESSION_H
+#define __DRMAA_UTILS__SESSION_H
+
+#include <sys/time.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/thread.h>
+
+/** Creates new DRMAA session. */
+fsd_drmaa_session_t *
+fsd_drmaa_session_new( const char *contact );
+
+/**
+ * Get current (global) DRMAA session
+ * and increase it's reference count.
+ */
+fsd_drmaa_session_t *
+fsd_drmaa_session_get(void);
+
+/**
+ * An action to be taken when job is missing from queue.
+ */
+typedef enum {
+	/**
+	 * Always raise #FSD_ERRNO_INTERNAL_ERROR (one per job)
+	 * in drmaa_wait() or drmaa_synchronize()
+	 * when job disappearance is spotted.
+	 */
+	FSD_REVEAL_MISSING_JOBS,
+	/**
+	 * Treat missing jobs as terminated with status
+	 * depending on last known state and action (drmaa_control()).
+	 */
+	FSD_IGNORE_MISSING_JOBS,
+	/**
+	 * Treat missing jobs as terminated
+	 * but only before they enter into running state.
+	 */
+	FSD_IGNORE_QUEUED_MISSING_JOBS
+} fsd_missing_jobs_behaviour_t;
+
+
+/** DRMAA session data. */
+struct fsd_drmaa_session_s {
+	/** Release one reference to DRMAA session. */
+	void (*
+	release)( fsd_drmaa_session_t *self );
+
+	/**
+	 * Destroy session after ensuring no other references to it are held.
+	 *
+	 * May block until reference count decreases to 1.
+	 * May return before actual session destruction if another thread
+	 * have already taken responsibility for freeing session.
+	 */
+	void (*
+	destroy)(
+			fsd_drmaa_session_t *self );
+
+	/**
+	 * Destroy session without waiting for releasing references.
+	 */
+	void (*
+	destroy_nowait)( fsd_drmaa_session_t *self );
+
+
+	/** Implements drmaa_run_job(). */
+	char* (*
+	run_job)(
+			fsd_drmaa_session_t *self,
+			const fsd_template_t *jt
+			);
+
+	/** Implements drmaa_run_bulk_jobs(). */
+	fsd_iter_t* (*
+	run_bulk)(
+			fsd_drmaa_session_t *self,
+			const fsd_template_t *jt,
+			int start, int end, int incr
+			);
+
+	/** Implements drmaa_control(). */
+	void (*
+	control_job)(
+			fsd_drmaa_session_t *self,
+			const char *job_id, int action
+			);
+
+	/** Implements drmaa_job_ps(). */
+	void (*
+	job_ps)(
+			fsd_drmaa_session_t *self,
+			const char *job_id, int *remote_ps
+			);
+
+	/** Implements drmaa_synchronize(). */
+	void (*
+	synchronize)(
+			fsd_drmaa_session_t *self,
+			const char **input_job_ids, const struct timespec *timeout,
+			bool dispose
+			);
+
+	/**
+	 * Implements drmaa_wait() call.
+	 * @param self     DRMAA session.
+	 * @param job_id   Job identifer to wait for or #DRMAA_JOB_IDS_SESSION_ANY
+	 * @param timeout  Timeout after which call shall raise
+	 *   #FSD_DRMAA_ERRNO_EXIT_TIMEOUT if job not terminated or \c NULL.
+	 * @param status   Terminated job status (output only).
+	 * @param rusage   Job resource usage (output only).
+	 * @see drmaa_wait()
+	 * @see #wait_for_single_job  #wait_for_any_job
+	 */
+	char* (*
+	wait)(
+			fsd_drmaa_session_t *self,
+			const char *job_id, const struct timespec *timeout,
+			int *status, fsd_iter_t **rusage
+			);
+
+	/**
+	 * Construct new job object.
+	 * @return Reference to newly created job.
+	 */
+	fsd_job_t* (*
+	new_job)( fsd_drmaa_session_t *self, const char *job_id );
+
+	char* (*
+	run_impl)(
+			fsd_drmaa_session_t *self,
+			const fsd_template_t *jt, int bulk_incr
+			);
+
+	/**
+	 * Wait until given job terminates (either successfuly or not).
+	 * @param self     DRMAA session.
+	 * @param job_id   Identifier of job to wait for.
+	 * @param timeout  If not \c NULL and job does not terminate
+	 *   in given amount of time function returns and
+	 *   #FSD_DRMAA_ERRNO_EXIT_TIMEOUT is raised.
+	 * @param status   If not \c NULL job status code is stored here.
+	 * @param rusage   If not \c NULL list of used resources is returned.
+	 * @param dispose  If \c true job information is removed from session
+	 *   at the end of call and further accesses to this job_id will
+	 *   raise #FSD_DRMAA_ERRNO_INVALID_JOB.  Otherwise job data is held.
+	 * @see #wait_for_any_job #wait
+	 */
+	void (*
+	wait_for_single_job)(
+			fsd_drmaa_session_t *self,
+			const char *job_id, const struct timespec *timeout,
+			int *status, fsd_iter_t **rusage, bool dispose
+			);
+
+	/**
+	 * Wait until and job left in session terminates.
+	 * @return  Identifier of waited job.
+	 *   Freeing responsobility is left to the callee.
+	 * @see #wait_for_single_job #wait
+	 */
+	char* (*
+	wait_for_any_job)(
+			fsd_drmaa_session_t *self,
+			const struct timespec *timeout,
+			int *status, fsd_iter_t **rusage,
+			bool dispose
+			);
+
+	void (*
+	wait_for_job_status_change)(
+			fsd_drmaa_session_t *self,
+			fsd_cond_t *wait_condition,
+			fsd_mutex_t *mutex,
+			const struct timespec *timeout
+			);
+
+	void* (*
+	wait_thread)( fsd_drmaa_session_t *self );
+
+	void (*
+	stop_wait_thread)( fsd_drmaa_session_t *self );
+
+	/**
+	 * Make status of all jobs held in session up to date.
+	 */
+	void (*
+	update_all_jobs_status)( fsd_drmaa_session_t *self );
+
+	/** Return list of all jobs within session. */
+	char** (*
+	get_submited_job_ids)(
+			fsd_drmaa_session_t *self
+			);
+
+	/**
+	 * Get job with given identifier.
+	 * @return New reference to job or \c NULL
+	 *   if no job found.
+	 */
+	fsd_job_t* (*
+	get_job)(
+			fsd_drmaa_session_t *self, const char *job_id
+			);
+
+	/**
+	 * Tries to load configuration from following locations in order
+	 * (configuration settings from later locations override
+	 * those from earlier):
+	 * /etc/basename.conf, ~/.basename.conf, $basename_CONF.
+	 */
+	void (*
+	load_configuration)(
+			fsd_drmaa_session_t *self, const char *basename
+			);
+
+	void (*
+	read_configuration)(
+			fsd_drmaa_session_t *self,
+			const char *filename, bool must_exist,
+			const char *configuration, size_t config_len
+			);
+
+	void (*
+	apply_configuration)(
+			fsd_drmaa_session_t *self
+			);
+
+	/** Reference counter. */
+	int ref_cnt;
+
+	/**
+	 * Whether #destroy was called and waits for releasing
+	 * references.  If set pending #wait calls shall
+	 * return with #FSD_DRMAA_ERRNO_NO_ACTIVE_SESSION error.
+	 */
+	bool destroy_requested;
+
+	/**
+	 * Copy of contact string passed to drmaa_init()
+	 * or default contact if drmaa_init() was called with \c NULL.
+	 */
+	char *contact;
+
+	/**
+	 * Jobs submitted within this DRMAA session
+	 * and not disposed yet.
+	 */
+	fsd_job_set_t *jobs;
+
+	/** DRMAA configuration. */
+	fsd_conf_dict_t *configuration;
+
+	/** Queue pooling delay (time delta). */
+	struct timespec pool_delay;
+
+	/**
+	 * Cache job state for number of seconds.
+	 * If positive drmaa_job_ps() returns remembered state without
+	 * communicating with DRM for \a cache_job_state seconds since last
+	 * update.
+	 */
+	int cache_job_state;
+
+	/** Whether to wait for jobs in separate thread. */
+	bool enable_wait_thread;
+
+	/**
+	 * Configuration dictionary which maps
+	 * job categories to native specification.
+	 */
+	fsd_conf_dict_t *job_categories;
+
+	/**
+	 * How to behave when submitted job disappears from DRM queue.
+	 */
+	fsd_missing_jobs_behaviour_t missing_jobs;
+
+	fsd_mutex_t mutex; /**< Mutex for accessing session data. */
+	fsd_cond_t wait_condition;  /**< Conditional for drmaa_wait() */
+	fsd_cond_t destroy_condition;  /**< Conditional for ref_cnt==1 */
+
+	/**
+	 * Mutex for accessing connection to DRM.
+	 *
+	 * To prevent deadlocks #mutex should be acquired first
+	 * when both session data and DRM connection are needed.
+	 */
+	fsd_mutex_t drm_connection_mutex;
+
+	fsd_thread_t wait_thread_handle;
+	bool wait_thread_started;
+	bool wait_thread_run_flag;
+};
+
+
+typedef struct fsd_drmaa_ctx_s {
+	fsd_drmaa_session_t *session;
+	fsd_mutex_t session_mutex;
+	
+} fsd_drmaa_ctx_t;
+
+
+extern fsd_drmaa_ctx_t fsd_drmaa_ctx;
+
+#endif /* __DRMAA_UTILS__SESSION_H */
+
